require 'fog-pry/version'
require 'fog-pry/fog_client'
require 'recursive-open-struct'

module Fog
  module FogProvider
    def fog(type)
      FogClient.new(type, config.send(type))
    end

    def config
      @config ||= load_config
    end

    def reload_config
      @config = nil
      config
    end

    def config_file
      ENV['FOG_CONFIG_FILE'] || "#{ENV['HOME']}/.fogpryrc"
    end

    def load_config
      RecursiveOpenStruct.new(YAML.load(File.read(config_file)), :recurse_over_arrays=>true)
    end
  end
end
